#include <stdio.h>
int pole[77][77];
int n_x, n_y;

int is_conflict(int x, int y, int co) {
    if (pole[y][x] == ' ') return co;
    if (pole[y][x] == co ) return co;
    if (pole[y][x] == 'x' && (co=='\\' || co=='/'))
      return 'x';
      
    if (pole[y][x] == '+' && (co=='|' || co=='-'))
     return '+';
     
    if ((pole[y][x] == '|') && (co == '-')) 
       return '+';
    if ((pole[y][x] == '-') && (co =='|'))
	return '+';
    if ((pole[y][x] == '/') && (co == '\\')) 
       return 'x';
    if ((pole[y][x] == '\\') && (co == '/'))
	return 'x';
    return '*';
}

int write(int x, int y, int co) {
    int result;
    result = is_conflict(x, y, co);
    pole[y][x] = result;
}

void draw_point(int x, int y) {
    write(x, y, 'o');
}

int draw_line(x1, y1, x2, y2) {
    int tmpx1, tmpx2, tmpy1, tmpy2, i,  pos; 
    if (y1==y2 && x1==x2) 
    {
      write(x1, y1, 'o');
      return 0;
    }
    
    if (y1 == y2) { 
	if (x1 <= x2) {
	    tmpx1 = x1;
	    tmpx2 = x2;
	}
	else {
	    tmpx1 = x2;
	    tmpx2 = x1;
	}
	
	pos = tmpx2- tmpx1;

	for (i = 0; i <= pos; i++ ) {
	    write(tmpx1+i, y1, '-');
	}
	return 1;
    }
    
    if (x1 == x2) {
	if (y1 <= y2) {
	    tmpy1 = y1;
	    tmpy2 = y2;
	}
	else {
	    tmpy1 = y2;
	    tmpy2 = y1;
	}
	pos = tmpy2 - tmpy1;
	for (i = 0; i <= pos; i++) {
	    write(x1, tmpy1+i, '|');
	}
	return 1;
    }
    
    if (x1 < x2) {
	tmpx1 = x1;
	tmpx2 = x2;
    }
    else {
	tmpx1 = x2;
	tmpx2 = x1;
    }
    pos = tmpx2-tmpx1;
    if (y1 < y2) {
	for (i = 0; i <= pos; i++ ) {
	    write(tmpx1 + i, y1 + i, '\\');
	}
    }
    else {
	for (i = 0; i <= pos;  i++) {
	    write(tmpx1 +i, y1 - i, '/');
	}
    }

}

void clear(int x1, int y1, int x2, int y2)
{
  int tmpx1, tmpx2;
  int tmpy1, tmpy2;
  int i, j;
  
  if (x1<x2) 
  {
    tmpx1 = x1;
    tmpx2 = x2;
  } else 
  {
    tmpx1 = x2;
    tmpx2 = x1;
  }
  
  if (y1<y2) 
  {
    tmpy1 = y1;
    tmpy2 = y2;
  } else
  {
    tmpy1 = y2;
    tmpy2 = y1;
  }
  for (i=tmpy1; i<=tmpy2; i++)
    for (j=tmpx1; j<=tmpx2; j++)
      pole[i][j] = ' ';
}


int main(void) {
    int i, j;
    int x1, y1, x2, y2;
    char cmd[10];
    char text[75];

    while (1)
{
    
    scanf("%d %d\n", &n_x, &n_y);
    if (n_x==0 && n_y==0)
       return 0;
       
    for (i = 0; i <= 76; i++) 
	for (j = 0; j<= 76; j++)
	    pole[i][j] = ' ';
	    
    while (1) {
    scanf("%s", cmd);
    if (strcmp("POINT", cmd) == 0) {
	scanf("%d %d\n", &x1, &y1);
		
	draw_point(x1, y1);
    }
    if (strcmp("LINE", cmd) == 0) {
	scanf("%d %d %d %d\n", &x1, &y1, &x2, &y2);
	draw_line(x1, y1, x2, y2);
    
    }
    
    if (strcmp("TEXT", cmd) == 0) {
      scanf("%d %d %s\n", &x1, &y1, text);
      for (i=0; i<strlen(text); i++)
        write(x1+i, y1, text[i]);    
    }
    
    if (strcmp("CLEAR", cmd)==0) {
      scanf("%d %d %d %d\n", &x1, &y1, &x2, &y2);
      clear(x1,y1,x2,y2);
    }
    
    if (strcmp("PRINT", cmd) == 0) {
        pole[0][0] = '+';
	pole[0][n_x+1] = '+';
	pole[n_y+1][0] = '+';
	pole[n_y+1][n_x+1] = '+';
	
	for (i=1; i<=n_x; i++)
	{
	  pole[0][i] = '-';
	  pole[n_y+1][i] = '-';
	}
	for (i=1; i<=n_y; i++)
	{
	  pole[i][0] = '|';
	  pole[i][n_x+1] = '|';
	}
	
	for (i = 0; i <= n_y+1; i++) { 
	    for (j=0; j <= n_x+1; j++)
		printf("%c", pole[i][j]);
	    printf("\n");	
	}
	printf("\n");
	break;
    }
    }
}    
    
    return 0;
}